/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file IFormatter.h
 *
 *\date  Created on: 10-mar-2009
 *\author  Author: Claudio Salvadori
 *\brief Interface for data formatter
 */
#ifndef IFORMATTER_H
#define IFORMATTER_H

#include <vector>
#include <string>
#include <stdlib.h>

#include "form_enum.h"
#include "DAQ_struct.h"
#include "DAQ_enum.h"

/**\class IFormatter
*\brief Interface for data formatter*/
class IFormatter{
	public:
		virtual ~IFormatter() {};

		/**\brief This method creates the header vector and the formatted data vector 
		*\param metadata	Metadata vector
		*\return One of the possible value of f_ret \see f_ret  
		*/
		virtual f_ret init (std::vector<struct SMData>* metadata) = 0;		

		/**\brief Fill the vector of formatted data 
		*\param msg 	Pointer to a char vector of data to be formatted received from IStreamReader (input) 
		*\return One of the possible value of f_ret \see f_ret */
		virtual f_ret getData (unsigned char* pkt) = 0;

};
#endif
