/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file IStreamReader.h
 *\date  Created on: 29-apr-2009
 *\author  Author: Claudio Salvadori
 *\brief  Interface for different type of stream reader*/

#ifndef ISTREAMREADER_H
#define ISTREAMREADER_H

#include <vector>
#include <string>

#include "Stream_enum.h"
#include "DAQ_struct.h"

//IStreamDaq.h
#include "CSerial.h"
#include "CFile.h"
#include "CPipe.h"
#include "CSocket.h"

//IDecoderDaq.h
#include "CXor.h"

//IMessageDaq.h
#include "CMessager.h"

/**\class IStreamReader
 *\brief  Interface for different type of stream reader*/
class IStreamReader{
	public:

	virtual ~IStreamReader() {};
			
	/** \brief Initialize all the classes linked with reader with the stream definition
	*\return This method return one of the possible value from s_ret \see s_ret*/
	virtual s_ret getDefinition (struct SDef def) = 0;
	
	/**\brief This method divides the packet recived into message to be formatted (the lenght of each message is
	*		the pkt_lenght defined in the xml file)
	*\param buffer 	Pointer to a pointer of a vector of the messages to be formatted (output)
	*\return This method return one of the possible value from s_ret \see s_ret*/
	virtual s_ret retStream(std::vector<struct SMessage> *buffer) = 0;
	
};
#endif
